C     ******************************************************************
C     ******************************************************************

      program algencanma

      implicit none

#include "dim.par"

C     PARAMETERS
      integer nassetsmax,nscenmax
      parameter ( nassetsmax = 1000 )
      parameter ( nscenmax   = 1000 )

C     COMMON SCALARS
      logical usetc
      integer algtype,nassets,nscen,r
      double precision ctol,inbeta,inMtot,infixc,inrfrc,inctol

C     COMMON ARRAYS
      integer find(nscenmax)
      double precision theta(nscenmax,nassetsmax),thetave(nassetsmax)

C     LOCAL SCALARS
      logical checkder,ieqsets
      integer i,inform,iprint,j,m,n,ncomp
      double precision cnorm,epsfeas,epsopt,f,nlpsupn,snorm

C     LOCAL ARRAYS
      logical coded(10),equatn(mmax),linear(mmax)
      integer findp(nscenmax)
      double precision l(nmax),lambda(mmax),u(nmax),x(nmax)

C     COMMON BLOCKS
      common /probdata/ theta,thetave,find,ctol,nassets,nscen,r
      common /metadata/ algtype,usetc,inbeta,inMtot,infixc,inrfrc,inctol

C     EXTERNAL SUBROUTINES
      external algencan,ieqsets,param

C     Set version
      open(10,file='metadata.txt')
      read(10,*) algtype,usetc,inrfrc,inctol
      write(*,*) 'algtype = ',algtype
      write(*,*) 'usetc   = ',usetc
      write(*,*) 'inrfrc  = ',inrfrc
      write(*,*) 'inctol  = ',inctol
      if ( usetc ) then
          read(10,*) inbeta,inMtot,infixc
          write(*,*) 'inbeta  = ',inbeta
          write(*,*) 'inMtot  = ',inMtot
          write(*,*) 'infixc  = ',infixc
      end if
      close(10)

      call param(epsfeas,epsopt,iprint,ncomp)

      call inip(n,x,l,u,m,lambda,equatn,linear,coded,checkder)

      if ( algtype .eq. 3 ) call compfind(n,x)

 10   continue

      call algencan(epsfeas,epsopt,iprint,ncomp,n,x,l,u,m,lambda,equatn,
     +linear,coded,checkder,f,cnorm,snorm,nlpsupn,inform)

      if ( algtype .eq. 3 ) then

          do i = 1,nscen
              findp(i) = find(i)
          end do

          call compfind(n,x)

          if ( .not. ieqsets(r,findp,find) ) then
              go to 10
          end if

          write(*,*)
          write(*,*) 'Convergence detected!'
          write(*,*)

      end if

      call endp(n,x,l,u,m,lambda,equatn,linear)

      stop

      end

C     ******************************************************************
C     ******************************************************************

      subroutine param(epsfeas,epsopt,iprint,ncomp)

C     SCALAR ARGUMENTS
      integer iprint,ncomp
      double precision epsfeas,epsopt

      epsfeas  = 1.0d-08
      epsopt   = 1.0d-08

      iprint   = 10
      ncomp    = 6

      end

